using DTO;
using Shared;
using StubApi;
using Contextlib;
using Entity;
using StubbedContextLib;
using ServicesApi;
var builder = WebApplication.CreateBuilder(args);
//API
builder.Services.AddScoped<IUserService<UserDTO>, UserService>();
builder.Services.AddScoped<IQuoteService<QuoteDTO>, QuoteServiceStub>(); // Retirer "Stub"


//EF
builder.Services.AddScoped<WTFContext, StubWTFContext>();
builder.Services.AddScoped<IUserService<Users>, DbUsersManager>();
// builder.Services.AddScoped<IUserService<Quote>, DbQuoteManager>(); Quand DbQuoteManager sera prsent
//builder.Services.AddScoped<IUserService<Character>, DbCharacterManager>();
//builder.Services.AddScoped<IUserService<Commentary>, DbCommentaryManager>();
//...

// Add services to the container.

builder.Services.AddControllers();
builder.Services.AddOpenApiDocument(options => {
    options.PostProcess = document =>
    {
        document.Info = new NSwag.OpenApiInfo
        {
            Version = "v1",
            Title = "What The Fantasy's API",
            Description = "What The Fantasy Site API",
            TermsOfService = "",
            Contact = new NSwag.OpenApiContact
            {
                Name = "The PM Mobile What The Fantasy team",
                Url = ""
            },
            License = new NSwag.OpenApiLicense
            {
                Name = "No license",
                Url = "https://license.fr"
            }
        };
    };
});


// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseOpenApi(); // Active la documentation OpenAPI
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
